# Generated by sila2.code_generator; sila2.__version__: 0.9.2
from __future__ import annotations

from abc import ABC, abstractmethod
from typing import TYPE_CHECKING

from sila2.server import FeatureImplementationBase, MetadataDict, ObservableCommandInstance

from .turbidityprovider_types import GetTurbidity_Responses

if TYPE_CHECKING:
    from ...server import Server


class TurbidityProviderBase(FeatureImplementationBase, ABC):
    parent_server: Server

    def __init__(self, parent_server: Server):
        """

        Monitoring the turbidity, e.g. of a reactor.

        """
        super().__init__(parent_server=parent_server)

    @abstractmethod
    def GetTurbidity(
        self, Wavelenth: float, *, metadata: MetadataDict, instance: ObservableCommandInstance
    ) -> GetTurbidity_Responses:
        """
        Get Current current turbidity at wavelength


        :param Wavelenth: Wavelength at which the turbidity is measured

        :param metadata: The SiLA Client Metadata attached to the call
        :param instance: The command instance, enabling sending status updates to subscribed clients

        :return:

            - Turbidity: Current Turbidity


        """
        pass
